<!-- 图片上传 -->
<template>
  <div class="needsclick">
    <form class="needsclick"> 
      <!-- capture="camera"  multiple="multiple" -->
      <input  class="needsclick" v-show="false" type="file" accept="image/*" @change="fileChanged" ref="file">
    </form>

    <van-action-sheet v-model="show" :actions="actions" @select="onSelect" cancel-text="取消" />
  </div>
</template>

<script>
/**@augments
 * @function  success(res)  成功回调
 * @function  error(res)    错误回调
 *
 */

import lrz from "lrz";
export default {
  data() {
    return {
      show: false,
      img: '',
      imgInfo: {
        url: ''
      },
      actions: [
        {
          name: '拍照',
          type: '1',
        },
        {
          name: '相册',
          type: '2',

        },

      ]
    };
  },
  methods: {
    fileChanged() {
      let len = this.$refs.file.files.length;
      if (!len) return false;
      //上传中
      this.m_loading(this.$t('upload_ing'))

      let quality = this.$refs.file.files[0].size / 2014 > 300 ? 0.8 : 1;
      lrz(this.$refs.file.files[0], { quality }).then(rst => {
        this.img = rst.base64;

        //ret.file  压缩后的文件
        // this.submit(rst);
      });
      // this.submit(this.$refs.file.files[0]);
    },
    
  

    submit(rst) {
      //上传中
      this.m_loading(this.$t('upload_ing'))
      let that = this;
      console.log('name',rst.file.name,rst)
      let formData = new FormData();
      formData.append("images", rst.file);
      //  formData.append("image", rst);

      var xhr = new XMLHttpRequest();
      xhr.open("POST", `${this.m_action}`, true);
      xhr.withCredentials = true;
      xhr.timeout = 10000; //超时
      xhr.onload = function () {
        if (xhr.status === 200 || xhr.status === 304) {
          //  console.log('success',this.response)
          let res = JSON.parse(this.response);

          that.imgInfo.url = res.data;
          
          that.m_hideLoading()
          let code = res.code
          console.log(res)
          if(code!=0){
             that.$emit("error", res);
            that.m_toast(res.message)
            return
          }
          that.$emit("success", that.imgInfo);
        }
      };

      //错误上传
      xhr.onerror = function (res) {
        console.log("上传错误");
        that.m_hideLoading()
        that.$emit("error", res);
      };

      xhr.ontimeout = function (res) {
        console.log("上传超时");
        that.m_hideLoading()
        that.$emit("error", res);

      };

      xhr.send(formData);
    },
    //生成名字
    rename(rst) {
      return new Date().getTime() + (new Array(2).fill().map(i => (~~(Math.random() * 10))).join('')) + '.' + rst.origin.name.split('.').reverse()[0]
    },

    //阻止默认行为
    clickimg() {
      return false
    },

    addbtn() {
      let an =''
      try {
        var _sys = plus.os.name
         an = _sys == 'Android'
      } catch (error) {
         an =''
      }
      
      let isApp = window.location.href.includes('ISAPP')

    //  this.$refs.file.click()
      if (isApp && an) {
        this.show = true;
      } else {
        this.$refs.file.click()
      }

    },

    onSelect(item) {
      this.show = false;
      if (item.type == 1) {
        console.log('拍照')
        this.cameraimages()
      } else if (item.type == 2) {
        console.log('相册')
        this.$refs.file.click()
      }
    },

     // 拍照添加文件
        cameraimages() {
          let that = this
            var cmr = plus.camera.getCamera();
            cmr.captureImage(function (p) {
                console.log('拍好图片', p)
                plus.io.resolveLocalFileSystemURL(p, function (entry) {
                    entry.file((file)=>{
                    var filereader = new plus.io.FileReader();
                    filereader.readAsDataURL(file);
                    filereader.onload = function (event) {
                    var data = event.target.result;

                    // that.img = data;
                      //that.appendFile(data)
                      that.handelLrz(data)
                    };
                    
                 //  that.a_lrz(file)
                    
                }); 
                   
                });
            }, function (e) {
               // alert('失败')
            });

        },



    handelLrz(path) { 
      this.m_loading('上传中..')
      lrz(path, { quality: 0.8 }).then(rst => {
        this.img = rst.base64;

        this.submit(rst);
      });

    },






  }
};
</script>
<style lang='scss' scoped>
</style>